<h1 align="center">
  <br>
  <a href="https://github.com/vchinnipilli/kubestriker"><img align="center" src="https://raw.githubusercontent.com/vchinnipilli/kubestriker/master/media/kube-striker.png"  height="400" width="400"></a>
</h1>

<h4 align="center"> A Blazing fast Security Auditing tool for <a href="https://kubernetes.io/" target="_blank">kubernetes</a>!!</h4>

![Python](https://img.shields.io/badge/python-v3.0+-blue.svg?style=plastic)
![Contributions welcome](https://img.shields.io/badge/contributions-welcome-orange.svg?style=plastic)
[![GitHub Issues](https://img.shields.io/github/issues/vchinnipilli/kubestriker?style=plastic)](https://github.com/vchinnipilli/kubestrike/issues)
![Stars Badge](https://img.shields.io/github/stars/vchinnipilli/kubestriker?style=plastic)
[![Hits](https://hits.seeyoufarm.com/api/count/incr/badge.svg?url=https%3A%2F%2Fgithub.com%2Fvchinnipilli%2Fkubestriker&count_bg=%2379C83D&title_bg=%23555555&icon=&icon_color=%23E7E7E7&title=Visitors&edge_flat=false)](https://hits.seeyoufarm.com)
[![Maintenance](https://img.shields.io/badge/Maintained%3F-yes-green.svg?style=plastic)](https://github.com/vchinnipilli/kubestriker)
[![License](https://img.shields.io/badge/license-Apache_License_2.0-blue.svg?style=plastic)](https://opensource.org/licenses/Apache_License_2.0)
<br/><br/>
### [**Overview & Journey of Kubestriker**](https://www.kubestriker.io/Getting-Started)

**Kubestriker** is a platform-agnostic tool designed to tackle **Kuberenetes cluster** security issues due to misconfigurations and will help strengthen the overall IT infrastructure of any organisation. 

It performs numerous in depth checks on a range of services and open ports well across more than one platform such as self hosted [kubernetes](https://kubernetes.io/), [Amazon EKS](https://aws.amazon.com/eks), [Azure AKS](https://azure.microsoft.com/en-us/services/kubernetes-service/), [Google GKE](https://cloud.google.com/kubernetes-engine) etc., to identify any misconfigurations which make organisations an easy target for attackers. In addition, it helps safeguard against potential attacks on Kubernetes clusters by continuously scanning for anomalies.

Furthermore, it comprises the ability to see some components of kubernetes infrastructure and provides visualised attack paths of how hackers can advance their attacks.

<br/><br/>
### [**Command Line Interface**](https://www.kubestriker.io/Command-Line-Interface)
<p align="center"> <img src="https://raw.githubusercontent.com/vchinnipilli/kubestriker/master/media/auth.gif" width="1000" height="500"/> </p>

<br/><br/>
### **Useful Links to Installation and usage of CLI**

- [**Current Capabilities**](https://www.kubestriker.io/Current-Capabilities#CurrentCapabilities)
- [**Installation**](https://www.kubestriker.io/Installation)
- [**Various use Cases**](https://www.kubestriker.io/Various-use-Cases)
- [**Reporting**](https://www.kubestriker.io/Reports#Reports)
- [**Kubestriker for various platforms**](https://www.kubestriker.io/Kubestriker-for-various-platforms)

<br/><br/>
### [**Web Application version**](https://www.kubestriker.io/Web-Application)
<p align="center"> <img src="https://raw.githubusercontent.com/vchinnipilli/kubestriker/master/media/webapp.png" width="1000" height="500"/> </p>
<br/><br/>


**Useful Links to Installation and usage of Web Application**
- [**Current Capabilities**](https://www.kubestriker.io/Current-capabilities#Currentcapabilities)
- [**Deploying Kubestriker**](https://www.kubestriker.io/-Deploying-Kubestriker)
- [**Kubestriker for various platforms**](https://www.kubestriker.io/Kubestriker-for-various-platforms)

<br/><br/>
## [**CI/CD Integration**](https://www.kubestriker.io/CICD-Integrations#CICDIntegrations)

Kubestriker was made capable of CICD integration with DevOps pipeline tools such as Jenkins, Azure pipelines and Bamboo. This allows for continuous scanning of the infrastructure to identify any misconfigurations prior to deployment into Sandbox or Production environments.
<br/><br/>
## [**Product Roadmap**](https://www.kubestriker.io/Product-Roadmap#ProductRoadmap)

Despite its rapid adoption, Kubernetes remains an evolving technology and container usage for production deployments in organizations is still constrained by concerns around security and monitoring. So, I see this as an opportunity to address these concerns and offer more advanced capabilities and make Kubestriker the preferred application for security auditing. It is going to be an exciting road ahead!
<br/><br/>
## [**Contributions Welcome**](https://www.kubestriker.io/Contributions#Contributions)

The journey of  Kubestriker has just begun. So while the  Kubestriker community of adopters and contributors are growing steadily, I hope to continue the expansion of its use and take it even further by collaborating with more users and getting more contributors on board.
<br/><br/>
## [**Helping Hands**](https://www.kubestriker.io/Contributions#Contributions)

* **Nag Meruva**
* **Chaitanya Nampalli**
* **Rupali Dash**
* **Pralhad Chaskar**
<br/><br/>
##  [**Support**](https://www.kubestriker.io/Contact#Contact)
[**Vasant Chinnipilli**](https://cloudsecguy.dev) builds and maintains kubestriker to audit and secure kubernetes infrastructure. 

Start with [**Documentation**](https://www.kubestriker.io) for quick tutorials and examples.

If you liked using this tool or it has helped you in any way or if you have any suggestions/improvements, I'd like you send me an email at <vchinnipilli@gmail.com> about anything you'd want to say about this tool. I'd really appreciate it!
<br/><br/>
##  [**Kubestriker in media**](https://www.kubestriker.io/Kubstriker-in-Media#KubstrikerinMedia)

## [**License**](https://github.com/vchinnipilli/kubestriker/blob/master/LICENSE)


## [**Find me here!!** <img src="https://raw.githubusercontent.com/vchinnipilli/kubestriker/master/media/wave.gif" width="30px">](https://www.linkedin.com/in/vasantreddy/)
[![cloudsecguy.dev](https://img.shields.io/badge/-https://www.cloudsecguy.dev-brightgreen?style=plastic&label=web:&logoColor=white&link=https://www.cloudsecguy.dev/)](https://www.cloudsecguy.dev/)
[![Linkedin Badge](https://img.shields.io/badge/-vasantChinnipilli-blue?style=plastic&logo=Linkedin&logoColor=white&link=https://www.linkedin.com/in/vasantreddy/)](https://www.linkedin.com/in/vasantreddy/)
[![Medium Badge](https://img.shields.io/badge/-@vasantchinnipilli-03a57a?style=plastic&labelColor=000000&logo=Medium&link=https://medium.com/@vasantkumarchinnipilli/)](https://medium.com/@vasantkumarchinnipilli)
[![Gmail Badge](https://img.shields.io/badge/-vchinnipilli@gmail.com-c14438?style=plastic&logo=Gmail&logoColor=white&link=mailto:vchinnipilli@gmail.com)](mailto:vchinnipilli@gmail.com)

